      subroutine centra(iatom,ipt,st,cel,cosi,icntra,dismax)            CENT001
c ----------------------------------------------------------------------CENT002
c     find central atom closest to origin for faster cluster expansion  CENT003
c ----------------------------------------------------------------------CENT004
c     This program module is part of the PhysiSoft X-ray Library        CENT005
c     and may not be sold or reproduced for commercial purposes.        CENT006
c     Although it has been tested carefully, there is no warranty       CENT007
c     regarding accuracy or freedom from side-effects.                  CENT008
c                   (C) 1986-1990 Bernhard Rupp                         CENT009
c ----------------------------------------------------------------------CENT010
      parameter (iat=20)                                                CENT011
      dimension st(iat,192,4),ipt(iat),icntra(iat),cel(3),cosi(3),xa(3) CENT012
                                                                        CENT013
      dismax=0.0                                                        CENT014
      do 1005 ia=1,iatom                                                CENT015
c --- calculate the distance from origin --                             CENT016
         do 1006 j=1,ipt(ia)                                            CENT017
            do 1001 k=1,3                                               CENT018
 1001          xa(k)=st(ia,j,k)*cel(k)                                  CENT019
            st(ia,j,4)=distan(iortho,xa,cosi)                           CENT020
            if(st(ia,j,4).gt.dismax) dismax=st(ia,j,4)                  CENT021
 1006    continue                                                       CENT022
         dmin=10E+10                                                    CENT023
c ---    icntra points to central atom of expansion --                  CENT024
         icntra(ia)=0                                                   CENT025
         do 1007 i=1,ipt(ia)                                            CENT026
            if (st(ia,i,4).lt.dmin) then                                CENT027
               dmin=st(ia,i,4)                                          CENT028
               icntra(ia)=i                                             CENT029
            end if                                                      CENT030
 1007    continue                                                       CENT031
 1005 continue                                                          CENT032
                                                                        CENT033
      return                                                            CENT034
      end                                                               CENT035
                                                                        CENT036
                                                                        CENT037
                                                                        CENT038
